#include <console.h>
#include <keyboard.h>
#include <video.h>
#include <stdio.h>
#include <string.h>
#include <system.h>
#include <labwars.h>

// Initialize console
void Console::initConsole()
{
	Video::Clear();
	printk("\nOS console started...\n");
	printk("Type \"list\" for list of commands\n");
	printk("Type \"help\" for basic help\n");
	printk("CTRL + ALT + DELETE to Reboot\n");
	printk("\n\n>>");
}

// Run console
void Console::runConsole(unsigned char scancode)
{
	// User pressed enter
	if(scancode == 0x1c)
	{
		Console::handle_commands(Keyboard::get_keyboard_buffer());
		Keyboard::clear_keyboard_buffer();
		printk("\n>>");
	}
	
	else if(scancode == 0xe)
		printk("\b");
	
	else if(scancode < 128)
	{
		printk("%c", Keyboard::get_ascii_char());
	}
		
}


// Print list of commands
void Console::list_commands()
{
	printk("\nList of Commands:\n");
	printk("list : Lists this table\n");
	printk("help : Displays basic help\n");
	printk("run  : Runs an application.\n");
	printk("       Only a game is avaliable, it runs game directly\n\n");
	printk("cls  : Clears screen\n");
	printk("reboot : Restarts computer\n");
	printk("exit   : Same with reboot for now\n");
}

// Display help
void Console::display_help()
{
	printk("\nHelp:\n");
	printk("Welcome to AKOS version 0.01\n");
	printk("It has support for application running,\n");
	printk("but only hard coded applications runs for now.\n");
	printk("System has 1 game application as hard coded inside.\n\n");
	printk("Type \"list\" to see list of avaliable commands\n");
	printk("If you get bored, press CTRL+ALT+DELETE , and this will reboot\n");
}

// Normally this will get a parameter, and run that application
// but there is only 1 application(game) avaliable for now
// so it starts that game directly
void Console::run_application()
{
	LabWars::initialize_game();
}

// Handle all commands
void Console::handle_commands(char *command)
{	
	if(strcmp(command, "list") == 0)
		list_commands();
	
	else if(strcmp(command, "help") == 0)
		display_help();
	
	else if(strcmp(command, "run") == 0)
		run_application();

	else if(strcmp(command, "cls") == 0)
	{
		Video::Clear();
		runConsole(129); // A bigger number than 128, to make console idle
	}
	
	else if(strcmp(command, "reboot") == 0)
		System::Reboot();
	
	else if(strcmp(command, "exit") == 0)
		System::Reboot();
	
	else
	{
		printk("\nUnknown command \"%s\"\n", command);
		printk("Try using \"help\"\n");
	}
}
