#ifndef __ASM_H
#define __ASM_H

/* SOURCE CODE TAKEN FROM osfaq2 */

/**** INLINE ASSEMBLY DEFINITIONS ****/

/* these are taken from different internet sources, 
   they are avaliable everywhere */

static inline void outportb(unsigned short port, unsigned char val)
{
	asm volatile("outb %0,%1"::"a"(val), "Nd" (port));
}

static inline unsigned char inportb (unsigned short _port)
{
    unsigned char rv;
    asm volatile("inb %1, %0" : "=a" (rv) : "dN" (_port));
    return rv;
}

static inline void enable_interrupts()
{
	asm("sti"); 
}

static inline void disable_interrupts()
{
	asm("cli");
}

/**************************************/



#ifdef __cplusplus
extern "C" {
#endif

unsigned GetEBP();
void UpdateGDT(unsigned limit, void* base);
extern int StackLimit;

//	
extern void keyboard_handler();
extern void timer_handler();
extern void remap_pics();
//

#ifdef __cplusplus
}
#endif

#endif
