#ifndef __KEYBOARD_H
#define __KEYBOARD_H

#define BUFF_SIZE 512 // 512byte keyboard temp
#define MAP_SIZE 128  // Keyboard map size

class Keyboard
{
	private:
		static int shift;
		static int ctrl;
		static int alt;
		static int capsLock;
		static int asciiChar;
		static int tempIndex; // Index of keyboard buffer
		static char keyboardBuffer[BUFF_SIZE]; // Keyboard buffer
		static char keyboardMap[MAP_SIZE]; // Keyboard map
		
		// Some shift chars are PARTLY! supported
		static char keyboardMapWithShift[MAP_SIZE];
		
		// Keyboard buffer is a temporary space to hold pressed keys
		static void handle_keyboard_buffer(char);
		
		// Handle keyboard maps, SHIFT, CAPSLOCK options...
		static char handle_keyboard_map(unsigned char);
	
		Keyboard();

	public:
		//Init keyboard
		static void init();	
	
		// Handle keyboard scancodes
		static void handle_keyboard(unsigned char);
	
		// Get ASCII char 
		static char get_ascii_char();
	
		// Get flagged keys
		static int Keyboard::get_alt_key();
		static int Keyboard::get_shift_key();
		static int Keyboard::get_ctrl_key();
		static int Keyboard::get_capslock_key();
	
		// Get keyboard buffer
		static char* get_keyboard_buffer();
	
		//Clear keyboard buffer
		static void clear_keyboard_buffer();
};

#endif
