#include <labwars.h>
#include <stdio.h>
#include <video.h>
#include <timer.h>
#include <string.h>
#include <console.h>


int LabWars::isInited = 0;
int LabWars::playerX;
int LabWars::playerY;
int LabWars::labsX[LABCOUNT];
int LabWars::labsY[LABCOUNT];
char LabWars::lab_names[LABCOUNT][7];

void LabWars::drawShip()
{
	Video::SetCursor(playerX, playerY);
	printk("O\\");
	Video::SetCursor(playerX, playerY + 1);
	printk("OX>");
	Video::SetCursor(playerX, playerY + 2);
	printk("O/");
}

// Initialize game
void LabWars::initialize_game()
{
	strcpy(lab_names[0], "bil137\0");
	strcpy(lab_names[1], "bil138\0");
	strcpy(lab_names[2], "bil235\0");
	strcpy(lab_names[3], "bil236\0");
	strcpy(lab_names[4], "bil341\0");
	strcpy(lab_names[5], "bil342\0");
	
	playerX = 0;
	playerY = 0;
	
	labsX[0] = 120;
	labsY[0] = 4;
	
	labsX[1] = 140;
	labsY[1] = 8;
	
	labsX[2] = 130;
	labsY[2] = 12;
	
	labsX[3] = 170;
	labsY[3] = 9;
	
	labsX[4] = 195;
	labsY[4] = 11;
	
	labsX[5] = 200;
	labsY[5] = 20;
	
	Video::Clear();
	printk("\nWELCOME TO UNFINISHED GAME LABWARS!!!\n");
	printk("\nUSE:");
	printk("\nARROW KEYS TO MOVE");
	printk("\nFIRE1: Q");
	printk("\nFIRE2: W");
	printk("\n\nPress ESC exit from game...");
	isInited = 1;
}

// Run game engine...
void LabWars::run_game_engine()
{
	static int counter = 9; // Game will start in 10 seconds...
	
	if(Timer::get_ticks() % 18 == 0)
		counter--;
	
	if(counter >= 0)
	{
		Video::SetCursor(0,9);
		printk("Game will start in %d", counter);
	}
	
	if(counter < 0)
	{
		Video::Clear();
		drawShip();
		labs_display();
		
		if(Timer::get_ticks() % 2 == 0)
			labs_coming();
	}
	
}

int LabWars::isGameInited()
{
	return isInited;
}

// Handle Game keys
void LabWars::handle_keys(unsigned char scancode)
{
	if(scancode == 0x48)
		playerY--;
	
	else if(scancode == 0x4d)
		playerX++;
	
	else if(scancode == 0x4b)
		playerX--;
	
	else if(scancode == 0x50)
		playerY++;
	
	else if(scancode == 0x10)
		printk("boom \n");
	
	else if(scancode == 0x11)
		printk("guuum\n");

	else if(scancode == 0x1)
	{
		isInited = 0;
		Console::initConsole();
	}
}

void LabWars::labs_coming()
{
	for(int i=0; i < LABCOUNT; ++i)
	{
		labsX[i]--;
		
	}
}

void LabWars::labs_display()
{
	for(int i=0; i < LABCOUNT; ++i)
	{
		if(!(labsX[i] >= 80 || labsY[i] >= 25))
		{
			Video::SetCursor(labsX[i], labsY[i]);
			printk("%s", lab_names[i]);
		}
	}
}
